

/* "vine3 extends water" means that there are a lot
	of routines in water.java that this applet imports
	and uses, so if you want to understand this code,
	read and understand water.java first.

	The routines in this file replace those in water.java
	that have the same names. This is called "class inheritance".
	This allows a small amount of code to slightly modify
	existing programs that can be very large.

	Anyway. This is my bit for Java toy-making. I am Neal McDonald,
	this is my code, take and eat, but leave in a pointer to me:
	www.workly.com
	*/


import java.applet.*;
import java.awt.*;
import java.awt.image.*;


public class vine3 extends water {

	final static int C=9;
	final static int DDIR=10;
	final static int DDDIR=11;

	int p2init;
	int pathMakers;

	void initPart(int which) {
		int r, g, b, cx, cy;
		double gx, gy;

		if (which<pathMakers) {
			gx = Math.random() * imageX * imageXscale;
			gy = Math.random() * imageY * imageYscale;

			parts[which][DIR] = Math.random() *360.0;
			parts[which][UPD] = 999999999.0;
			parts[which][JUMPED] = 0.0;
			parts[which][SPEED] = 3.0;

			parts[which][DDIR] = 25.0;
			parts[which][DDDIR] = 0.0;

			partColors[which] = backgroundColor;
			parts[which][XPOS] = gx;
			parts[which][YPOS] = gy;
		} else {
			parts[which][UPD] = -1.0;
		}
	}


	/* for which >= pathMakers*/
	void initPartB(int which, int source) {
		int r, g, b, cx, cy;
		double gx, gy;

		gx = parts[source][XPOS];
		gy = parts[source][YPOS];
		parts[which][XPOS] = gx;
		parts[which][YPOS] = gy;
		parts[which][OX] = gx;
		parts[which][OY] = gy;

		parts[which][DIR] = 20.0;
		if (Math.random()>.5) {
			parts[which][DDIR] = 40.0;
		} else {
			parts[which][DDIR] = -40.0;
		}
		parts[which][DDDIR] = 20.0;
		parts[which][JUMPED] = 0.0;
		parts[which][SPEED] = 5.0;
		parts[which][UPD] = 10.0;

		r = getColorG((int)gx,(int)gy);
		parts[which][C] = (double)r;

		partColors[which] = new Color(r, r, r);
	}


	void initMore() {
		pathMakers =
			java.lang.Integer.parseInt(getParameter("pathMakers"));
		p2init = pathMakers;
	}

	void drawPart(Graphics gr, int which) {
		int px,py,ox,oy, r,or,tc,dc1, dc2;
		double wear;

		if (which>pathMakers) {
			if ((parts[which][JUMPED] < 0.01)
				&&(parts[which][UPD]>0)){
				px = ((int)parts[which][XPOS]);
				py = ((int)parts[which][YPOS]);
				ox = ((int)parts[which][OX]);
				oy = ((int)parts[which][OY]);
				r = getColorG(px,py);
				tc = (int)(parts[which][C]);

				dc1 = r-tc;
				if (dc1<0) { dc1 = 0-dc1; }

				/* if we're in the wrong color, start to die */
				if (dc1>50) {
					wear = 2.0 * (dc1/256.0);
					parts[which][UPD] -= wear;
				}
					/* draw in any case */
				r_setColor(gr, partColors[which]);
				r_drawLine(gr, px,py,ox,oy);
			}
		}
	}



	void movePart(int which) {
		double dx, dy;
		int ix, jumped;

		if ((simTicks%5==0) && (which<pathMakers)) {
			initPartB(p2init, which);
			++p2init;
			if (p2init==NUM_PARTS) { p2init=pathMakers; }
		}

		if (parts[which][UPD] > 0.0) {
			ix = (int)(parts[which][DIR]) % 360;
			if (ix<0) ix+=360;
			parts[which][OX] = parts[which][XPOS];
			parts[which][OY] = parts[which][YPOS];
			parts[which][XPOS] += parts[which][SPEED] * cosines[ix];
			parts[which][YPOS] += parts[which][SPEED] * sines[ix];

			dx = parts[which][DDIR];
			if (which<pathMakers) {
				dx = (Math.random()*dx) - (dx*0.5);
			}
			parts[which][DIR] += dx;

			dx = parts[which][DDDIR];
			dx = (Math.random()*dx) - (dx*0.5);
			parts[which][DDIR] += dx;


			jumped=0;
			if (parts[which][XPOS] > MAX_X) {
				parts[which][XPOS] = MIN_X;
				jumped=1;
			}
			if (parts[which][XPOS] < MIN_X) {
				parts[which][XPOS] = MAX_X;
				jumped=1;
			}
			if (parts[which][YPOS] > MAX_Y) {
				parts[which][YPOS] = MIN_Y;
				jumped=1;
			}
			if (parts[which][YPOS] < MIN_Y) {
				parts[which][YPOS] = MAX_Y;
				jumped=1;
			}
			parts[which][JUMPED] = (double)jumped;
			parts[which][UPD] -= 0.2;
		}
	}
}

